
#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

int main(void)
{
    /* System generated locals */
    int i__1, i__2, i__3;

    /* Builtin functions */
    double cos(double), sin(double);

    /* Local variables */
    extern int f_c();
    static double h__;
    static int j, l, m;
    static double p[104], q, s[119], u[28]  /* was [2][14] */, x;
    static int k0;
    static double au[32] /* was [2][16] */, xk;
    static int nx;
    static double xp, yp[2], yt[2], yx[2];
    static int kp1, kp2;
    static double xj0[14], ajk[30]  /* was [2][15] */, alp[14],
                  zfi[34] /* was [2][17] */, hd4i[15];
    extern int de44d_c( );
    static double rabc[14], cmar[196]  /* was [14][14] */,
                  ajkp[30]  /* was [2][15] */, alpn[14], dely[2];
    static int imax, iniapr, jstarn, jstart;

/*       take into consideraitoin: all arraies dependent on K */
/*              must be described for maximal value K */
    m = 2;
    q = .5;
    x = -.44444444444444442;
    yx[0] = cos(q * (x * 2. - 1.)) + 1.;
    yx[1] = sin(q * (x * 2. - 1.)) + 1.;
    h__ = .1111111111111111;
    xk = x + h__;
    yt[0] = cos(q * (xk * 2. - 1.)) + 1.;
    yt[1] = sin(q * (xk * 2. - 1.)) + 1.;
    imax = 10;
    jstarn = 0;
    jstart = jstarn;
    iniapr = 1;
    k0 = 6;

    de44d_c((U_fp)f_c, &m, &k0, &iniapr, &imax, &jstart, yx, &x, xj0, au, ajk,
            &h__, hd4i, rabc, alp, alpn, cmar, p, s, &xp, yp, ajkp, u, zfi);
    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];

    printf("\n --------------------------------------------------------\n");
    printf( "\n RESULTS AFTER THE FIRST CALL SUBROUTINE DE44D \n");
    printf("\n xp = %21.14e x = %21.14e\n", xp, x);
    printf("\n h__=%21.14e k=%2i iniapr= %1i imax=%3i jstart(initial)=%3i\n",h__, k0,iniapr,imax,jstarn);

    printf("\n yx[0]= %21.14e yx[1]= %21.14e\n", yx[0], yx[1]);
    printf("\n yt[0]= %21.14e yt[1]= %21.14e\n", yt[0], yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e \n", dely[0], dely[1]);
    printf("\n --------------------------------------------------------\n");

    nx = 1;
    goto L15;
/* _______________________________________ */

L1:
    h__ = .33333333333333331;
    xk = x + h__;
    yt[0] = cos(q * (xk * 2. - 1.)) + 1.;
    yt[1] = sin(q * (xk * 2. - 1.)) + 1.;
    imax = 14;

/*  take into consideraitoin: parameter JSTART must be equal to zero */

    jstart = jstarn;
    k0 = 8;

    de44d_c((U_fp)f_c, &m, &k0, &iniapr, &imax, &jstart, yx, &x, xj0, au, ajk,
            &h__, hd4i, rabc, alp, alpn, cmar, p, s, &xp, yp, ajkp, u, zfi);
    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];
    printf("\n --------------------------------------------------------\n");
    printf( "\n RESULTS AFTER THE SECOND CALL SUBROUTINE DE44D \n");
    printf("\n xp = %21.14e x = %21.14e\n", xp, x);
    printf("\n h__=%21.14e k=%3i iniapr= %1i imax=%3i jstart(initial)=%3i\n",h__, k0,iniapr,imax,jstarn);

    printf("\n yx[0]= %21.14e yx[1]= %21.14e\n", yx[0], yx[1]);
    printf("\n yt[0]= %21.14e yt[1]= %21.14e\n", yt[0], yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e \n", dely[0], dely[1]);
    printf("\n --------------------------------------------------------\n");

    nx = 2;
    goto L15;
/* ____________________________________ */

L2:
    h__ = 1.;
    xk = x + h__;
    yt[0] = cos(q * (xk * 2. - 1.)) + 1.;
    yt[1] = sin(q * (xk * 2. - 1.)) + 1.;
    imax = 17;

/*  take into consideraitoin: parameter JSTART must be equal to zero */

    jstart = jstarn;
    k0 = 11;
    de44d_c((U_fp)f_c, &m, &k0, &iniapr, &imax, &jstart, yx, &x, xj0, au, ajk,
            &h__, hd4i, rabc, alp, alpn, cmar, p, s, &xp, yp, ajkp, u, zfi);
    dely[0] = yt[0] - yx[0];
    dely[1] = yt[1] - yx[1];

    printf("\n --------------------------------------------------------\n");
    printf( "\n RESULTS AFTER THE THIRD CALL SUBROUTINE DE44D \n");
    printf("\n xp = %21.14e x = %21.14e\n", xp, x);
    printf("\n h__=%21.14e k=%2i iniapr= %1i imax=%3i jstart(initial)=%3i\n",h__, k0,iniapr,imax,jstarn);

    printf("\n yx[0]= %21.14e yx[1]= %21.14e\n", yx[0], yx[1]);
    printf("\n yt[0]= %21.14e yt[1]= %21.14e\n", yt[0], yt[1]);
    printf("\n dely");
    printf("\n %23.14e %23.14e \n", dely[0], dely[1]);
    printf("\n --------------------------------------------------------\n");

    nx = 3;
L15:
    kp2 = k0 + 2;
    kp1 = k0 + 1;
    printf("\n COEFFICIENTS AU AND AJK ON %3i SEGMENT\n", nx);

    i__1 = m;
    for (l = 1; l <= i__1; ++l) {
    printf("\n ---------------------------------------------------");
    printf("\n\n        Chebyshev coefficients for %1i component \n", l );
    printf("\n              for  Y                 for  Y' \n" );

	i__2 = kp1;
	for (j = 1; j <= i__2; ++j) {
	    i__3 = j - 1;
      printf("\n %3i %23.14e %23.14e ", i__3, au[l + (j << 1) - 3], ajk[l + (j << 1) - 3]);
	}
      printf("\n %3i %23.14e ", kp1, au[l + (kp2 << 1) - 3]);
/* L20: */
    }
    printf("\n\n ");
    switch (nx) {
	case 1:  goto L1;
	case 2:  goto L2;
	case 3:  goto L7;
    }
L7:
/* L48: */
/* L50: */
/* L161: */
    return 0;
} /* main */

/*.................................................................*/

 int f_c(double *x, double *y, double *z__, int *m)
{
    /* Builtin functions */
    double cos(double), exp(double), sin(double);

    /* Local variables */
    static double q, r__;

    /* Parameter adjustments */
    --z__;
    --y;

    /* Function Body */
    q = .5;
    r__ = *x * 2. - 1.;
    z__[1] = q * -2. * (y[2] - 1.) + (1. - exp(1. - y[1] + cos(q * r__))) /
            (*x + 1.);
    z__[2] = q * 2. * (y[1] - 1.) + (1. - exp(1. - y[2] + sin(q * r__))) /
            (*x + 1.);
    return 0;
} /* f_c */
